function[out]=invregDiscrete(x,y)
%[out]=invreg(x,y,numrep) does the dimension reduction based on 
%sliced inverse regression. Each row of x and y represent an observation.
%numrep: the number of observations in each slice.


n=length(y);
% if exist('numslice')==0
%     numslice=10;   
% end
%[sy,ind]=sort(y);
mx=mean(x);
%numrep=round(n/numslice);
matx=0;xbar=[]; uy=unique(y);
for j=1:length(uy)
    x1=x(y==uy(j),:); 
    numrep=length(find(y==uy(j)));
    xbar(j,:)=mean(x1);
    matx=matx+numrep*(xbar(j,:)-mx)'*(xbar(j,:)-mx);
end
% xbar(numslice,:)=mean(x(ind((numslice-1)*numrep+1:n),:));
% matx=matx+(n-(numslice-1)*numrep)*(xbar(numslice,:)-mx)'*(xbar(numslice,:)-mx);
matx=(cov(x)*(n-1))^(-1)*matx;
[sv,sd]=eig(matx); 
temp=abs(diag(sd));[a,b]=sort(-temp);sd=temp(b);sv=sv(:,b);
out.direction=sv;
out.eigenvalue=sd;
out.matx=matx;
%out.numrep=numrep;